/**
 * ---- 1.0.0
 * 
 *
 * Copyright 2015, Kate Kligman
 * All rights reserved.
 */


$(document).ready(function() {
    $(document).bind('keydown', onKeyDownHandler);

    window.doppler.init(function(bandwidth) {
        var threshold = 4;
        if (bandwidth.left > threshold || bandwidth.right > threshold) {
            var scale    = 10;
            var diff = bandwidth.left - bandwidth.right;

            if (Crafty.running)
              Crafty('player').move('n', diff);
        }
    });

    Crafty.init(640, 400, 'game');

    // Preload assets.
    Crafty.load(["img/ball_red.png", "img/rainbow_0.png"], function() {
        Crafty.scene('instructions');
    });

});

Crafty.scene('instructions', function() {

    Crafty.e("HTML")
        .attr({x:30, y:10, w: Crafty.viewport.width - 50, h: Crafty.viewport.height})
        .replace("" +
            "<h3 align='center'>GET READY TO WAVE AT PONG</h3><br/>" +
            "1. Have a mac laptop running chrome. Open laptop to a 90 degree angle.<br/><br/>" +
            "2. Turn up the onboard speakers to maximum.<br/><br/>" +
            "3. Allow chrome to use your microphone. Click 'Allow' on the permissions bar at the top of the browser. You might hear a high pitch sound.<br/>" +
            "<br/>When the game begins, wave your hand up and down near the screen to control the paddle. This works best if your laptop is open at a 90 degree angle." +
            "<br/><br/><br/><input type='button' value='Start Game' style='margin-left: 250px' onclick='javascript:Crafty.scene(\"game\");'>"
        );
});

Crafty.scene('game', function() {
    Crafty.running = true;
    Crafty.background('#ffffff url(img/rainbow_0.png)');


    Crafty.e("2D, DOM, Image, Multiway, Controls, Collision, player")
        .attr({
            dy: 2,
            dir: 1,
            x: Crafty.viewport.width - 20,
            y: Crafty.viewport.height / 2,
            decay: 0
        })
        .image('img/paddle.png')
        .multiway(10, {UP_ARROW: -90, DOWN_ARROW: 90})
        .bind("EnterFrame", function() {
            // Out of bounds
            if (this._y > Crafty.viewport.height - this._h - 5) {
                this.dir *= -1;
                this.y = Crafty.viewport.height - this._h - 5;
            }
            if (this._y < 0 + 5) {
                this.dir *= -1;
                this.y = 0 + 5;
            }

            //this.y += this.dy;
        });

    Crafty.e("2D, DOM, Image, Collision, Color, ball")
        .attr({
            w: 50,
            h: 50,
            x: 10,
            y: Crafty.viewport.height / 2,
            dx: 4,
            dy: 4
        })
        .image('img/ball_red.png')
        .bind("EnterFrame", function() {
            // Out of bounds.
            if (this._y <= 0 || this._y >= Crafty.viewport.height - this._h)
                this.dy *= -1;

            if (this._x <= -this._x)
                this.dx *= -1;

            this.x += this.dx;
            this.y += this.dy;
        })
        .onHit('player', function() {
            this.dx *= -1;
        });
});



// Cleaner code by Jonathan Porta
var onKeyDownHandler = function(e) {
    var gameKeys = [32, 37, 38, 39, 40];
    if($.inArray(e.which, gameKeys) > -1){
        e.preventDefault();
    }
    else if(e.which == 27) { //ESC key
        if(instance){
            instance.stop();
        }
    }
};
